#!/bin/sh

INSTALLER_NAME="Rootkit Hunter installer"
INSTALLER_VERSION="0.0.1"
INSTALLER_COPYRIGHT="Michael Boelen"

#################################################################################
#
# Installation options
#
#################################################################################

# Installation dir (please do not change, it's not dynamic...
# however it will be in future)
INSTALL_DIR="/usr/local/rkhunter"

INSTALLPREFIX="./files/"

# Install files
INSTALLFILES="
overwrite:check_modules.pl:/usr/local/rkhunter/scripts/check_modules.pl:Perl%%module%%checker
overwrite:check_port.pl:/usr/local/rkhunter/scripts/check_port.pl:Portscanner
overwrite:filehashmd5.pl:/usr/local/rkhunter/scripts/filehashmd5.pl:MD5%%Digest%%generator
overwrite:filehashsha1.pl:/usr/local/rkhunter/scripts/filehashsha1.pl:SHA1%%Digest%%generator
overwrite:rkhunter:/usr/local/bin/rkhunter:RK%%Hunter%%binary
overwrite:rkhunter.conf:/usr/local/etc/rkhunter.conf:RK%%Hunter%%configuration%%file
overwrite:showfiles.pl:/usr/local/rkhunter/scripts/showfiles.pl:Directory%%viewer
overwrite:backdoorports.dat:/usr/local/rkhunter/db/backdoorports.dat:Database%%Backdoor%%ports
overwrite:mirrors.dat:/usr/local/rkhunter/db/mirrors.dat:Database%%Update%%mirrors
overwrite:os.dat:/usr/local/rkhunter/db/os.dat:Database%%Operating%%Systems
overwrite:defaulthashes.dat:/usr/local/rkhunter/db/defaulthashes.dat:Database%%Default%%file%%hashes
overwrite:CHANGELOG:/usr/local/rkhunter/docs/CHANGELOG:Changelog
overwrite:README:/usr/local/rkhunter/docs/README:Readme%%and%%FAQ
overwrite:WISHLIST:/usr/local/rkhunter/docs/WISHLIST:Wishlist%%and%%TODO
"

# Create directories (only if they do not exist)
CREATEDIRS="
/usr/local/etc
/usr/local/rkhunter
/usr/local/rkhunter/db
/usr/local/rkhunter/docs
/usr/local/rkhunter/scripts
/usr/local/rkhunter/tmp
"

#################################################################################
#
# Start installation
#
#################################################################################


# Clean active window
clear

echo "${INSTALLER_NAME} ${INSTALLER_VERSION} (${INSTALLER_COPYRIGHT})"
echo "---------------"
echo "Starting installation/update"

CHECKDIR="/usr/local"

echo -n "Checking ${CHECKDIR}... "
if [ -d ${CHECKDIR} ]
  then
    echo "OK"
  else
    echo "Fatal error: $CHECK_DIR doesn't exists"
    exit
fi

echo -n "Checking file retrieval tools... "
SEARCH=`which wget`
if [ "${SEARCH}" = "" ]
  then
    SEARCH=`which fetch`
    if [ "${SEARCH}" = "" ]
      then
        echo "Error"
	echo "Fatal error: Cannot find 'wget' or 'fetch'"
	exit
      else
        RETRTOOL=${SEARCH}
    fi
  else
    RETRTOOL=${SEARCH}
fi

echo "OK. (Using ${RETRTOOL})"

echo "Checking installation directories... "

for I in ${CREATEDIRS}; do
  echo -n "   - Checking ${I}... "
  if [ -d ${I} ]
    then
      echo "Exists"
    else
      echo "Created"
      # Create directory
      mkdir -p ${I}
  fi
done

echo "Checking system settings... "

echo -n "    - Perl... "
if [ ! -f /usr/bin/perl ]
  then
    echo "Failed"
    echo ""
    echo "----------------------------------------------------------------------------------"
    echo "/usr/bin/perl cannot be found. Please create a symbolic link to your Perl binary"
    echo "ie. ln -s <path_to>/perl /usr/bin/perl"
    echo "----------------------------------------------------------------------------------"
  else
    echo "OK"
fi


echo "Installing files... "

for I in ${INSTALLFILES}; do
  
  INSTALLTYPE=`echo ${I} | cut -d ':' -f1`
  CURFILE=`echo ${I} | cut -d ':' -f2`
  NEWFILE=`echo ${I} | cut -d ':' -f3`
  DESCRIPTION=`echo ${I} | cut -d ':' -f4 | tr -s '%%' ' '`

  echo -n "Installing ${DESCRIPTION}... "
  if [ -f ${INSTALLPREFIX}${CURFILE} ]
    then
      cp -f ${INSTALLPREFIX}${CURFILE} ${NEWFILE}
      if [ $? -eq 0 ]
        then
	  echo "OK"
	else
	  echo "Failed"
      fi
    else
      echo "Failed (cannot find ${CURFILE})"
  fi
 
done

echo "Installation ready."
echo "See /usr/local/rkhunter/docs for more information. Run 'rkhunter'"





# End